function op = compute_prob_ord_bin(z_tilde, r_tilde, alpha, beta)
% computes p(r_tilde|z_tilde, alpha, beta) for the Ord-Binary model
%
% all input vectors assumed to be 1 x Knew sized vectors

op = prod((beta .^ ((1-z_tilde) & (1-r_tilde))) ...
  .* ((1-beta) .^ ((1-z_tilde) & r_tilde)) ... 
  .* (alpha .^ (z_tilde & r_tilde)) ...
  .* ((1-alpha) .^ (z_tilde & (1-r_tilde))));